<TeXmacs|1.0.7.19>

<style|<tuple|beamer|vdh|mathemagix>>

<\body>
  <\hide-preamble>
    <assign|pseudo-code|<\macro|body>
      <\padded-normal|1fn|1fn>
        <\indent>
          <\with|par-first|0fn|par-par-sep|0fn|font-size|0.917>
            <\ridged-paper>
              <surround||<right-flush>|<arg|body>>
            </ridged-paper>
          </with>
        </indent>
      </padded-normal>
    </macro>>

    <assign|blacken|<macro|x|<with|ornament-color|black|color|#c0ffc0|strong-color|#f0ffb0|math-color|#ffd4c0|ornament-sunny-color|dark
    grey|ornament-shadow-color|grey|<ornament|<arg|x>>>>>

    <assign|monitor|<\macro|body>
      <\padded-normal|1fn|1fn>
        <\indent>
          <\with|par-first|0fn|par-par-sep|0fn|font-size|0.917|font-family|tt>
            <\blacken>
              <surround||<right-flush>|<arg|body>>
            </blacken>
          </with>
        </indent>
      </padded-normal>
    </macro>>

    \;
  </hide-preamble>

  <screens|<\shown>
    <tit|Interfacing <name|Mathemagix> and C++>

    <\with|par-mode|center>
      <tabular*|<tformat|<cwith|4|4|2|2|cell-tsep|2spc>|<table|<row|<cell|>|<cell|>|<cell|>>|<row|<cell|>|<cell|<block*|<tformat|<cwith|1|1|1|1|cell-background|white>|<cwith|1|1|1|1|cell-lsep|1em>|<cwith|1|1|1|1|cell-rsep|1em>|<cwith|1|1|1|1|cell-bsep|1em>|<cwith|1|1|1|1|cell-tsep|1em>|<table|<row|<cell|<image|texmacs-chip.ps|0.7w|0.7h||>>>>>>>|<cell|>>|<row|<cell|>|<cell|>|<cell|>>|<row|<cell|>|<cell|Joris
      van der Hoeven, ISSAC 2013>|<cell|>>|<row|<cell|>|<cell|<verbatim|http://www.<anim-repeat|<anim-compose|<anim-constant|<with|color|brown|T<rsub|<space|-0.2spc><with|math-level|0|font-shape|small-caps|e>>X><with|color|dark
      green|<rsub|<with|math-level|0|font-shape|small-caps|macs>>>|1sec>|<anim-constant|<with|color|dark
      green|T<rsub|<space|-0.2spc><with|math-level|0|font-shape|small-caps|<with|color|brown|e>>>X><with|color|brown|<rsub|<with|math-level|0|font-shape|small-caps|macs>>>|1sec>>>.org>>|<cell|>>>>>
    </with>
  </shown>|<\hidden>
    <tit|Main design goals of Mathemagix>

    \;

    <\itemize>
      <unroll|<\shown>
        <item>Freely available from <verbatim|http://www.mathemagix.org>
        (including documentation)
      </shown>|<\hidden>
        <item>Strongly typed functional language for mathematical programming
      </hidden>|<\hidden>
        <item>Efficient compiler
      </hidden>|<\hidden>
        <item>Access to low level details and encapsulation
      </hidden>|<\hidden>
        <item>Inter-operability with C/C++ and other languages
      </hidden>|<\hidden>
        <item>Large scale programming <em|via> intuitive, strongly local
        writing style
      </hidden>|<\hidden>
        \;

        <\with|par-left|0cm>
          <\granite>
            <\render-theorem|Guiding principle>
              \;

              <tabular|<tformat|<table|<row|<cell|Prototype>|<cell|>|<cell|<math|\<leftrightsquigarrow\>>>|<cell|>|<cell|Mathematical
              theorem>>|<row|<cell|Implementation>|<cell|>|<cell|<math|\<leftrightsquigarrow\>>>|<cell|>|<cell|Formal
              proof>>>>>
            </render-theorem>
          </granite>
        </with>
      </hidden>>
    </itemize>
  </hidden>|<\hidden>
    <tit|Example>

    <\mmx-code>
      forall (R: Ring) square (x: R) == x * x;
    </mmx-code>

    <switch|<\shown>
      \;
    </shown>|<\hidden>
      <large|<vspace*|0.5fn><strong|Mathemagix>>

      <\mmx-code>
        category Ring == {

        \ \ convert: Int -\<gtr\> This;

        \ \ prefix -: This -\<gtr\> This;

        \ \ infix +: (This, This) -\<gtr\> This;

        \ \ infix -: (This, This) -\<gtr\> This;

        \ \ infix *: (This, This) -\<gtr\> This;

        }
      </mmx-code>

      <\note*>
        No mathematical ring properties required
      </note*>
    </hidden>|<\hidden>
      <large|<vspace*|0.5fn><strong|C++>>

      <\cpp-code>
        template\<less\>typename R\<gtr\>

        square (const R& x) {

        \ \ return x * x;

        }
      </cpp-code>
    </hidden>|<\hidden>
      <large|<vspace*|0.5fn><strong|C++>>

      <\cpp-code>
        <with|color|red|concept> Ring\<less\>typename R\<gtr\> {

        \ \ R::R (int);

        \ \ R::R (const R&);

        \ \ R operator - (const R&);

        \ \ R operator + (const R&, const R&);

        \ \ R operator - (const R&, const R&);

        \ \ R operator * (const R&, const R&);

        }

        \;

        template\<less\>typename R\<gtr\>

        <with|color|red|requires> Ring\<less\>R\<gtr\>

        operator * (const R& x) {

        \ \ return x * x;

        }
      </cpp-code>
    </hidden>|<\hidden>
      <large|<vspace*|0.5fn><strong|Axiom, Aldor>>

      <\mmx-code>
        <with|color|dark magenta|define> Ring: Category == with {

        \ \ 0: %;

        \ \ 1: %;

        \ \ -: % -\<gtr\> %;

        \ \ +: (%, %) -\<gtr\> %;

        \ \ -: (%, %) -\<gtr\> %;

        \ \ *: (%, %) -\<gtr\> %;

        }

        \;

        Square (R: Ring): with {

        \ \ square: R -\<gtr\> R;

        } == <with|color|dark magenta|add> {

        \ \ square (x: R): R == x * x;

        }

        \;

        import from Square (Integer);
      </mmx-code>
    </hidden>|<\hidden>
      <large|<vspace*|0.5fn><strong|Ocaml>>

      <\verbatim-code>
        <with|color|red|#> let square x = x * x;;

        <with|color|dark blue|val square: int -\<gtr\> int> =
        \<less\>fun\<gtr\>

        \;

        <with|color|red|#> let square_float x = x *. x;;

        <with|color|dark blue|val square_float: float -\<gtr\> float> =
        \<less\>fun\<gtr\>
      </verbatim-code>
    </hidden>|<\hidden>
      <large|<vspace*|0.5fn><strong|Ocaml>>

      <\verbatim-code>
        <with|color|red|#> module type RING =

        \ \ \ \ sig

        \ \ \ \ \ \ type t

        \ \ \ \ \ \ val cst : int -\<gtr\> t

        \ \ \ \ \ \ val neg : t -\<gtr\> t

        \ \ \ \ \ \ val add : t -\<gtr\> t -\<gtr\> t

        \ \ \ \ \ \ val sub : t -\<gtr\> t -\<gtr\> t

        \ \ \ \ \ \ val mul : t -\<gtr\> t -\<gtr\> t

        \ \ \ \ end;;

        \;

        <with|color|red|#> module Squarer =

        \ \ functor (El: RING) -\<gtr\>

        \ \ \ \ struct

        \ \ \ \ \ \ let square x = El.mul x x

        \ \ \ \ end;;

        \;

        <with|color|red|#> module IntRing =

        \ \ \ \ struct

        \ \ \ \ \ \ type t = int

        \ \ \ \ \ \ let cst x = x

        \ \ \ \ \ \ let neg x = - x

        \ \ \ \ \ \ let add x y = x + y

        \ \ \ \ \ \ let sub x y = x - y

        \ \ \ \ \ \ let mul x y = x * y

        \ \ \ \ end;;

        \;

        <with|color|red|#> module IntSquarer = Squarer(IntRing);;

        \;

        <with|color|red|#> IntSquarer.square 11111;;

        <with|color|dark blue|-> : int = 123454321
      </verbatim-code>
    </hidden>>
  </hidden>|<\hidden>
    <tit|Full genericity>

    <\mmx-code>
      do_something (K: Field, n: Int): Void == {

      \ \ ...

      \ \ if n\<gtr\>0 then do_something (Polynomial K, n-1);

      }

      \;

      for p: Int in 2..100000 do

      \ \ if prime? p then {

      \ \ \ \ F_p: Field == Modular (Int, p);

      \ \ \ \ do_something (F_p, p);

      \ \ }
    </mmx-code>

    \;
  </hidden>|<\hidden>
    <tit|Preparing for imports from C++>

    <\mmx-code>
      foreign cpp import {

      \ \ cpp_flags \ \ "\0numerix-config --cppflags\0";

      \ \ cpp_libs \ \ \ "\0numerix-config --libs\0";

      \ \ cpp_include "numerix/integer.hpp";

      \ \ ...

      }
    </mmx-code>
  </hidden>|<\hidden>
    <tit|Importing basic types and functions>

    <\mmx-code>
      foreign cpp import {

      \ \ cpp_flags \ \ "\0numerix-config --cppflags\0";

      \ \ cpp_libs \ \ \ "\0numerix-config --libs\0";

      \ \ cpp_include "numerix/integer.hpp";

      \;

      \ \ class Integer == integer;

      \ \ literal_integer: Literal -\<gtr\> Integer == make_literal_integer;

      \;

      \ \ prefix -: Integer -\<gtr\> Integer == prefix -;

      \ \ infix +: (Integer, Integer) -\<gtr\> Integer == infix +;

      \ \ infix -: (Integer, Integer) -\<gtr\> Integer == infix -;

      \ \ infix *: (Integer, Integer) -\<gtr\> Integer == infix *;

      \ \ ...

      }
    </mmx-code>

    Special constructor for literal integers such as <cpp|12345678987654321>:

    <\cpp-code>
      integer make_literal_integer (const literal&);
    </cpp-code>
  </hidden>|<\hidden>
    <tit|Syntactic sugar>

    <\description>
      <item*|Data access>

      <\mmx-code>
        postfix .x: Point -\<gtr\> Double == get_x;
      </mmx-code>

      <item*|Data conversions>

      <\mmx-code>
        upgrade: Integer -\<gtr\> Rational == keyword constructor;
      </mmx-code>

      <\mmx-code>
        downgrade: Colored_Point -\<gtr\> Point == as_point;
      </mmx-code>

      <item*|Tuples>

      <\mmx-code>
        num_vector: Tuple Double -\<gtr\> Num_Vector == keyword constructor;
      </mmx-code>

      <item*|Generators>

      <\mmx-code>
        downgrade: Num_Vector -\<gtr\> Generator Double == explode;
      </mmx-code>

      <\mmx-code>
        v: Num_Vector == ...;

        for x: Double in v do ...;
      </mmx-code>
    </description>
  </hidden>|<\hidden>
    <tit|Exporting to C++>

    <\mmx-code>
      foreign cpp export {

      \ \ class Point == point;

      \ \ point: (Double, Double) -\<gtr\> Point == keyword constructor;

      \ \ postfix .x: Point -\<gtr\> Double == get_x;

      \ \ postfix .y: Point -\<gtr\> Double == get_y;

      \ \ middle: (Point, Point) -\<gtr\> Point == middle;

      }
    </mmx-code>
  </hidden>|<\hidden>
    <tit|Implementing genericity: categories>

    <\mmx-code>
      category Monoid == {

      \ \ infix *: (This, This) -\<gtr\> This;

      }
    </mmx-code>

    <\cpp-code>
      class Monoid_rep: public rep_struct {

      \ \ inline Monoid_rep ();

      \ \ virtual inline ~Monoid_rep ();

      \ \ virtual generic mul (const generic&, const generic&) const = 0;

      \ \ ... \ 

      };

      \;

      typedef managed_pointer\<less\>Monoid_rep\<gtr\> Monoid;
    </cpp-code>
  </hidden>|<\hidden>
    <tit|Implementing genericity: function templates>

    <\mmx-code>
      forall (M: Monoid) cube (x: M): M == x*x*x;
    </mmx-code>

    <\cpp-code>
      generic

      cube (const Monoid& M, const generic& x) {

      \ \ // x is assumed to contain an object "of type M"

      \ \ return M-\<gtr\>mul (x, M-\<gtr\>mul (x, x));

      }
    </cpp-code>

    <\note*>
      <verbatim|generic> <math|\<leftrightsquigarrow\>> managed
      <verbatim|void*>
    </note*>
  </hidden>|<\hidden>
    <tit|Implementing genericity: instantiations>

    <\mmx-code>
      c: Int == cube 3;
    </mmx-code>

    <\mmx-code>
      struct Int_Ring_rep: public Ring_rep {

      \ \ ...

      \ \ generic

      \ \ mul (const generic& x, const generic& y) const {

      \ \ \ \ return as_generic\<less\>int\<gtr\>
      (from_generic\<less\>int\<gtr\> (x) *

      \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ from_generic\<less\>int\<gtr\>
      (y));

      \ \ }

      \ \ ...

      };
    </mmx-code>

    <\cpp-code>
      Monoid Int_Ring= new Int_Ring_rep ();

      int c= from_generic\<less\>int\<gtr\> (cube (Int_Ring,
      as_generic\<less\>int\<gtr\> (3)));
    </cpp-code>
  </hidden>|<\hidden>
    <tit|Importing C++ templates ...>

    <\mmx-code>
      foreign cpp import {

      \ \ ...

      \ \ class Pol (R: Ring) == polynomial R;

      \ \ 

      \ \ forall (R: Ring) {

      \ \ \ \ pol: Tuple R -\> Pol R == keyword constructor;

      \ \ \ \ upgrade: R -\> Pol R == keyword constructor;

      \;

      \ \ \ \ deg: Pol R -\> Int == deg;

      \ \ \ \ postfix []: (Pol R, Int) -\> R == postfix [];

      \;

      \ \ \ \ prefix -: Pol R -\> Pol R == prefix -;

      \ \ \ \ infix +: (Pol R, Pol R) -\> Pol R == infix +;

      \ \ \ \ infix -: (Pol R, Pol R) -\> Pol R == infix -;

      \ \ \ \ infix *: (Pol R, Pol R) -\> Pol R == infix *;

      \ \ \ \ ...

      \ \ }

      }
    </mmx-code>
  </hidden>|<\hidden>
    <tit|... requires exportation of categories>

    <\mmx-code>
      foreign cpp export

      category Ring == {

      \ \ convert: Int -\> This == keyword constructor;

      \ \ prefix -: This -\> This == prefix -;

      \ \ infix +: (This, This) -\> This == infix +;

      \ \ infix -: (This, This) -\> This == infix -;

      \ \ infix *: (This, This) -\> This == infix *;

      }
    </mmx-code>
  </hidden>|<\hidden>
    <tit|Two approaches to genericity>

    \;

    <center|Generic function arguments <math|\<leftrightsquigarrow\>> Pairs
    <math|<around*|(|value,type|)>>>

    \;

    <\description>
      <item*|Approach 1>Directly store pairs <math|<around*|(|value,type|)>>

      <with|color|green|<strong|<with|color|dark green|+>>> Allows for
      functional programming style<new-line><strong|<with|color|red|<math|<with|color|red|->>>>
      Needs tweaking of C++ code:<new-line> \ \ \ what is the type of the sum
      the elements in an empty vector?
    </description>

    \;

    <\description>
      <item*|Approach 2>Store the type in a global variable which is
      dynamically changed

      <with|color|green|<strong|<with|color|dark green|+>>> No need to tweak
      the C++ code<new-line><strong|<with|color|red|<math|<with|color|red|->>>>
      Less functional (<math|\<rightsquigarrow\>> more work for support of
      multi-threading)
    </description>
  </hidden>|<\hidden>
    <tit|Generic instance classes>

    <\cpp-code>
      template\<less\>typename Cat, int Nr\<gtr\>

      class instance {

      public:

      \ \ generic rep;

      \ \ <granite|static Cat Cur;>

      \ \ inline instance (const instance& prg2): rep (prg2.rep) {}

      \ \ inline instance (const generic& prg): rep (prg) {}

      \ \ instance ();

      \ \ template\<less\>typename C1\<gtr\> instance (const C1& c1);

      \ \ ...

      };
    </cpp-code>

    <\cpp-code>
      // export of infix *: (This, This) -\<gtr\> This == infix * from Ring

      template\<less\>int Nr\<gtr\> inline instance\<less\>Ring,Nr\<gtr\>

      operator * (const instance\<less\>Ring,Nr\<gtr\> &a1,

      \ \ \ \ \ \ \ \ \ \ \ \ const instance\<less\>Ring,Nr\<gtr\> &a2) {

      \ \ typedef instance\<less\>Ring,Nr\<gtr\> Inst;

      \ \ return Inst (Inst::Cur-\>mul (a1.rep, a2.rep));

      }
    </cpp-code>
  </hidden>|<\hidden>
    <tit|Importing C++ templates>

    <\mmx-code>
      forall (R: Ring)

      infix *: (Pol R, Pol R) -\<gtr\> Pol R;
    </mmx-code>

    <\cpp-code>
      polynomial\<less\>generic\<gtr\>

      mul (const Ring &R,

      \ \ \ \ \ const polynomial\<less\>generic\<gtr\> &p1,

      \ \ \ \ \ const polynomial\<less\>generic\<gtr\> &p2)

      {

      \ \ typedef instance\<less\>Ring,1\<gtr\> Inst;

      \ \ Ring old_R= Inst::Cur;

      \ \ Inst::Cur= R;

      \ \ polynomial\<less\>Inst\<gtr\> P1=
      as\<less\>polynomial\<less\>Inst\<gtr\> \<gtr\> (p1);

      \ \ polynomial\<less\>Inst\<gtr\> P2=
      as\<less\>polynomial\<less\>Inst\<gtr\> \<gtr\> (p2);

      \ \ polynomial\<less\>Inst\<gtr\> R = P1 * P2;

      \ \ polynomial\<less\>generic\<gtr\> r=
      as\<less\>polynomial\<less\>generic\<gtr\> \<gtr\> (R);

      \ \ Inst::Cur= old_R;

      \ \ return r;

      }
    </cpp-code>
  </hidden>|<\hidden>
    <tit|Final notes>

    <\description>
      <item*|Optimizations>

      <\mmx-code>
        p: Pol Integer == ...;

        q: Pol Integer == p * p;
      </mmx-code>

      <\cpp-code>
        polynomial\<less\>integer\<gtr\> p= ...;

        polynomial\<less\>integer\<gtr\> q= p * p;
      </cpp-code>

      <item*|Need for the <mmx|Nr> parameter>

      <\mmx-code>
        forall (R1: Ring, R2: Ring)

        map (f: R1 -\<gtr\> R2, v: Vector R1): Vector R2 == map;

        // R1 -\<gtr\> instance\<less\>Ring,1\<gtr\>

        // R2 -\<gtr\> instance\<less\>Ring,2\<gtr\>
      </mmx-code>

      <item*|Dependent types>

      Automagically works
    </description>

    \;
  </hidden>>
</body>

<\initial>
  <\collection>
    <associate|font-base-size|11>
    <associate|info-flag|none>
    <associate|language|english>
    <associate|page-screen-top|5mm>
    <associate|preamble|false>
    <associate|sfactor|5>
  </collection>
</initial>

<\references>
  <\collection>
    <associate|Taylor|<tuple|1|?>>
    <associate|auto-1|<tuple|<with|mode|<quote|math>|\<bullet\>>|?>>
    <associate|auto-2|<tuple|<with|mode|<quote|math>|\<bullet\>>|?>>
    <associate|auto-3|<tuple|<with|mode|<quote|math>|\<bullet\>>|?>>
    <associate|auto-4|<tuple|Miscellaneous corrections|?>>
    <associate|auto-5|<tuple|1|?>>
    <associate|comp-props|<tuple|1|?>>
    <associate|corrector-1-tab|<tuple|<with|mode|<quote|math>|\<bullet\>>|?>>
    <associate|corrector-2-tab|<tuple|<with|mode|<quote|math>|\<bullet\>>|?>>
    <associate|misinterpret-tab|<tuple|<with|mode|<quote|math>|\<bullet\>>|?>>
    <associate|posfig|<tuple|7|?>>
    <associate|tfin-t-bound|<tuple|1|?>>
    <associate|trlagr|<tuple|<with|mode|<quote|math>|\<bullet\>>|?>>
    <associate|ts-diff1|<tuple|<with|mode|<quote|math>|\<bullet\>>|?>>
    <associate|ts-diff2|<tuple|<with|mode|<quote|math>|\<bullet\>>|?>>
    <associate|ts-euler|<tuple|<with|mode|<quote|math>|\<bullet\>>|?>>
    <associate|ts-gamma|<tuple|<with|mode|<quote|math>|\<bullet\>>|?>>
    <associate|ts-transfin|<tuple|1|?>>
    <associate|ts-zeta|<tuple|1|?>>
  </collection>
</references>